package com.agiledeveloper.ticktacktoeui;

import com.agiledeveloper.ticktacktoe.TickTackToeBoard;

import javax.swing.*;
import java.awt.*;
import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;

/**
 * User: Venkat Subramaniam
 * Date: Jul 11, 2004
 * Time: 10:42:38 AM
 */
public class TickTackToeFrame extends JFrame
{
    private TickTackToeBoard board;

    private class ActionHandler implements ActionListener
    {
        public void actionPerformed(ActionEvent e)
        {
            if(!board.isGameOver())
            {
                JButton theButton = (JButton) e.getSource();
                String buttonName = theButton.getName();

                char firstChar = buttonName.charAt(0);
                char secondChar = buttonName.charAt(2);
                int row = Character.digit(firstChar, 10);
                int column = Character.digit(secondChar, 10);

                String peg = "O";
                if (board.isNextPlayerPegX())
                    peg = "X";
                board.placePeg(row, column);
                theButton.setText(peg);
                theButton.setEnabled(false);

                if (board.isGameOver())
                {
                    JOptionPane.showMessageDialog(TickTackToeFrame.this,  "Game Over " + peg + " won!");
                }
            }
        }
    }
    protected void frameInit()
    {
        super.frameInit();

        getContentPane().setLayout(new GridLayout(3, 3));

        for (int i = 0; i < 3; i++)
        {
            for (int j = 0; j < 3; j++)
            {
                  createButton(i + "_" + j);
            }
        }

        board = new TickTackToeBoard();
        board.firstPlayerIsX(true);
    }

    private void createButton(String name)
    {
        JButton button = new JButton();
        button.setName(name);
        button.addActionListener(new ActionHandler());
        getContentPane().add(button);
    }

    public static void main(String[] args)
    {
        JFrame frame = new TickTackToeFrame();
        frame.setSize(200, 200);
        frame.setDefaultCloseOperation(WindowConstants.EXIT_ON_CLOSE);
        frame.show();
    }
}